
/*
   Copyright 2012 Willem Vermin, SARA

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */

#include <sstream>
#include <iomanip>
template <class T>
inline std::string to_string (const T& t)
{
  std::stringstream ss;
  ss << t;
  return ss.str();
}
template <class T>
inline std::string to_string (const T& t,int w)
{
  std::stringstream ss;
  ss << std::setfill('0') << std::setw(w) << t;
  return ss.str();
}
template <class T>
inline T from_string (std::string t)
{
  std::stringstream ss;
  ss.str(t);
  T x;
  ss >> x;
  return x;
}
